"""actually do overlap entry detection ...

Revision ID: 6fea50bb8562
Revises: ea11786324dd
Create Date: 2018-07-09 22:09:40.044988

"""
from alembic import op
import sqlalchemy as sa


import impetuous.data

# revision identifiers, used by Alembic.
revision = '6fea50bb8562'
down_revision = 'ea11786324dd'
branch_labels = None
depends_on = None

check_insert_entry_dtrange = """
CREATE TRIGGER check_insert_entry_dtrange
BEFORE INSERT ON entry
FOR EACH ROW
BEGIN
    SELECT RAISE(ABORT, "entry start end overlap")
    WHERE EXISTS (
        SELECT 1 FROM entry e
        WHERE e.start <= NEW.start AND e.end   > NEW.start
           OR e.end   >  NEW.start AND e.start < NEW.end
    );
END;
"""

check_update_entry_dtrange = """
CREATE TRIGGER check_update_entry_dtrange
BEFORE UPDATE OF start, end ON entry
FOR EACH ROW
BEGIN
    SELECT RAISE(ABORT, "entry start end overlap")
    WHERE EXISTS (
        SELECT 1 FROM entry e
        WHERE e.id is not new.id
            AND (e.start <= NEW.start AND e.end   > NEW.start
             OR  e.end   >  NEW.start AND e.start < NEW.end)
    );
END;
"""


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.execute(check_insert_entry_dtrange)
    op.execute(check_update_entry_dtrange)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.execute("DROP TRIGGER check_insert_entry_dtrange")
    op.execute("DROP TRIGGER check_update_entry_dtrange")
    # ### end Alembic commands ###
